<?php
/**
* @Copyright Copyright (C) 2012 Alfred Bösch
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgContentBo_VideoJS extends JPlugin {
	
	public function onContentPrepare($context, &$article, &$params, $limitstart) {
		
		$app = JFactory::getApplication();
		
	  	$pluginParams = $this->params;
	
		if (!isset($GLOBALS['plg_bo_videojs'])) {
			$GLOBALS['plg_bo_videojs'] = 1;
		}
	
		$hits = preg_match_all('#{bo_videojs\s*(.*?)}#s', $article->text, $matches);
		
		if (!empty($hits)) {
			$document = JFactory::getDocument();

			if ($pluginParams->get('self_host') == "0") {
				$document->addStyleSheet(JURI::base().'plugins/content/bo_videojs/video-js/video-js.min.css');
				$document->addScript(JURI::base().'plugins/content/bo_videojs/video-js/video.min.js');
				$document->addScriptDeclaration('
					_V_.options.flash.swf = "'.JURI::base().'plugins/content/bo_videojs/video-js/video-js.swf";
					');
			} else {
				$document->addStyleSheet('http://vjs.zencdn.net/c/video-js.css');
				$document->addScript('http://vjs.zencdn.net/c/video.js');
			}
			
			$document->addStyleDeclaration('
			.videoWrapper {
				position: relative;
				padding-top: 0px;
				height: 0;
				z-index: 1000;
				overflow: hidden;
			}
			video {
				position: absolute !important;
				top: 0;
				left: 0;
				width: 100% !important;
				height: 100% !important;
				z-index: 1;
			}
			video.video-js {
				z-index: 1000;
			}
			.video-js .vjs-controls {
				z-index: 1002;
			}
			.video-js .vjs-big-play-button {
				z-index: 1002;
			}
			.videoWrapper .video-js {
				position: absolute;
				top: 0;
				left: 0;
				width: 100% !important;
				height: 100% !important;
				z-index: 1;
				background: #000000;
			}
			.videoWrapper object,
			.videoWrapper embed {
				position: absolute;
				top: 0;
				left: 0;
				width: 100%;
				height: 100% !important;
				z-index: 1;
			}
			.vjs-spinner {
			  /*display: none !important;*/
			}
			.video-js img.vjs-poster {
				height: 100% !important;
				width: 100% !important;
				max-width: 100%;
				z-index: 1;
			}');
			
			for ($i=$GLOBALS['plg_bo_videojs']; $i<$GLOBALS['plg_bo_videojs']+$hits; $i++) {

				for ($j=0; $j<$hits; $j++) {
					$videoParams = $matches[1][$j];
					$videoParamsList = $this->contentBoVideoJS_getParams($videoParams, $pluginParams);
					$html = $this->contentBoVideoJS_createHTML($i+$j, $pluginParams, $videoParamsList);
					$pattern = str_replace('[', '\[', $matches[0][$j]);
					$pattern = str_replace(']', '\]', $pattern);
					$pattern = str_replace('/', '\/', $pattern);
					$pattern = str_replace('|', '\|', $pattern);
			    	$article->text = preg_replace('/'.$pattern.'/', $html, $article->text, 1);
				}

			}
			
			// Count instances
			$GLOBALS['plg_bo_videojs'] += $hits;
		
		} else {
			return false;
		}

		return true;
		
	}
	
	protected function contentBoVideoJS_getParams($videoParams, $pluginParams) {

		$videoParamsList['width'] 				= $pluginParams->get('width');
		$videoParamsList['height'] 				= $pluginParams->get('height');
		$videoParamsList['controls']			= $pluginParams->get('controls');
		$videoParamsList['autoplay']			= $pluginParams->get('autoplay');
		$videoParamsList['preload']				= $pluginParams->get('preload');
		$videoParamsList['loop']				= $pluginParams->get('loop');
		$videoParamsList['poster_visibility']	= $pluginParams->get('poster_visibility');
		$videoParamsList['video_mp4']			= '';
		$videoParamsList['video_webm']			= '';
		$videoParamsList['video_ogg']			= '';
		$videoParamsList['poster']				= '';
		$videoParamsList['text_track']			= '';

		$items = explode(' ', $videoParams);
		
		foreach ($items as $item) {
			if ($item != '') {
				$item	= explode('=', $item);
				$name 	= $item[0];
				$value	= strtr($item[1], array('['=>'', ']'=>''));
				if ($name == "text_track") {
					$videoParamsList[$name][] = $value;
				} else {
					$videoParamsList[$name] = $value;
				}
			}
		}
		
		return $videoParamsList;
	}
	
	protected function contentBoVideoJS_createHTML($id, &$pluginParams, &$videoParamsList) {
		
		$width 				= $videoParamsList['width'];
		$height 			= $videoParamsList['height'];
		$controls			= $videoParamsList['controls'];
		$autoplay			= $videoParamsList['autoplay'];
		$preload			= $videoParamsList['preload'];
		$loop				= $videoParamsList['loop'];
		$poster_visibility	= $videoParamsList['poster_visibility'];
		$video_mp4			= $videoParamsList['video_mp4'];
		$video_webm			= $videoParamsList['video_webm'];
		$video_ogg			= $videoParamsList['video_ogg'];
		$poster				= $videoParamsList['poster'];
		$tracks				= $videoParamsList['text_track'];
		$ratio				= ($height/$width)*100;

		// Controls
		if ($controls == "1") {
			$controls_html 	= ' controls="controls"';
		} else {
			$controls_html 	= '';
		}
		
		// Autoplay
		if ($autoplay == "1") {
			$autoplay_html 	= ' autoplay="autoplay"';
		} else {
			$autoplay_html 	= '';
		}

		// Preload
		if ($preload == "auto" || $preload == "metadata" || $preload == "none") {
			$preload_html 	= ' preload="'.$preload.'"';
		}

		// Loop
		if ($loop == "1") {
			$loop_html		= ' loop="loop"';
		} else {
			$loop_html 		= '';
		}

		// Poster image
		if ($poster_visibility == "1" && $poster != "") {
			$poster_html 	= ' poster="'.$poster;
		} else {
			$poster_html 	= '';
		}
		
		// Text tracks
		if (!empty($tracks)) {
			$text_track_html = '';
			foreach ($tracks AS $track) {
				$track_items = explode('|', $track);
				$text_track_html .= '<track kind="'.$track_items[0].'" src="'.$track_items[1].'" srclang="'.$track_items[2].'" label="'.$track_items[3].'" />';			
			}	
		} else {
			$text_track_html = '';
		}
		
		// HTML output
		$html = '';
		
		$html = '<div class="videoSizer_'.$id.'"><div class="videoWrapper_'.$id.' videoWrapper">';

		$html .= '<video id="plg_bo_videojs_'.$id.'" class="video-js vjs-default-skin"'.$controls_html.$autoplay_html.$preload_html.$loop_html.$poster_html.'" data-setup="{}">';

		if (!empty($video_mp4)) {
			$html .= '<source src="'.$video_mp4.'" type="video/mp4" />';
		}

		if (!empty($video_webm)) {
			$html .= '<source src="'.$video_webm.'" type="video/webm" />';
		}

		if (!empty($video_ogg)) {
			$html .= '<source src="'.$video_ogg.'" type="video/ogg" />';
		}
		
		$html .= $text_track_html;

		$html .= '</video>';
		
		$html .= '</div></div>';
		
		$html .= '<style type="text/css">
		.videoSizer_'.$id.' { max-width: '.$width.'px; }
		.videoWrapper_'.$id.' { padding-bottom: '.$ratio.'%; }
		</style>';
		
		return $html;

	}
	
}