<?php
/**
* @Copyright Copyright (C) 2010 Alfred Bösch
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

class modBoVideoJSHelper {
	  
	function getVideo(&$params) {
		
		// Head
		$document =& JFactory::getDocument();

		// Check if videojs script is loaded
		$scripts = array_keys($document->_scripts);
		$foundVideoJSScripts = false;
		for ($i = 0; $i<count($scripts); $i++) {
			if (stripos($scripts[$i], 'video.js') !== false) {
				$foundVideoJSScripts = true;
			}
		}
		if (!$foundVideoJSScripts) {
			$document->addScript(JURI::base().'modules/mod_bo_videojs/videojs/video.js');
		}
		
		// Count instances
		if (!isset($GLOBALS['mod_bo_videojs'])) {
			$GLOBALS['mod_bo_videojs'] = 1;
		} else {
			$GLOBALS['mod_bo_videojs']++;
		}

		// Individual setup for each player
		$id	= $GLOBALS['mod_bo_videojs'];
		$document->addScriptDeclaration('VideoJS.DOMReady(function(){
			var mod_player_'.$id.' = VideoJS.setup("mod_bo_videojs_'.$id.'", {
				autoplay:				'.$params->get('autoplay', 'false').',
				preload:				'.$params->get('preload', 'true').',
				useBuiltInControls:		'.$params->get('useBuiltInControls', 'false').',
				controlsBelow: 			'.$params->get('controlsBelow', 'false').',
				controlsAtStart:		'.$params->get('controlsAtStart', 'false').',
				controlsHiding: 		'.$params->get('controlsHiding', 'true').',
				defaultVolume: 			'.$params->get('defaultVolume', '0.85').',
				playerFallbackOrder:	['.$params->get('playerFallbackOrder', '"html5", "flash", "links"').'],
				flashPlayerVersion: 	'.$params->get('flashPlayerVersion', '9').'
	    	});
		});');

		// Check if videojs stylesheets are loaded
		$styleSheets = array_keys($document->_styleSheets);
		$foundVideoJSStyles = false;
		for ($i = 0; $i<count($styleSheets); $i++) {
			if (stripos($styleSheets[$i], 'video-js.css') !== false) {
				$foundVideoJSStyles = true;
			}
		}
		if (!$foundVideoJSStyles) {
			$document->addStyleSheet(JURI::base().'modules/mod_bo_videojs/videojs/video-js.css');
		}

		if ($params->get('skin') != 'default') {
			$document->addStyleSheet(JURI::base().'modules/mod_bo_videojs/videojs/skins/'.$params->get('skin').'.css');
		}
		
		// Video
		$video_mp4			= $params->get('video_mp4');
		$video_webm			= $params->get('video_webm');
		$video_ogg			= $params->get('video_ogg');
		$flash				= $params->get('flash');
		$image 				= $params->get('image');
		$image_visibility	= $params->get('image_visibility');
		$uri_flash			= '';
		$uri_image			= '';
		
		// Player
		$width 				= $params->get('width');
		$height 			= $params->get('height');
		$autoplay			= $params->get('autoplay');
		$loop				= $params->get('loop');
		$skin				= '';
		$wmode				= $params->get('wmode', 'default');

		// Add URI for local flash video
		if (stripos($flash, 'http://') === false) {
			$uri_flash = JURI::base();		
		}
		
		// Add URI for local flash image
		if (stripos($image, 'http://') === false) {
			$uri_image = JURI::base();		
		}

		if ($params->get('skin', 'default') != 'default') {
			$skin 	= ' '.$params->get('skin').'-css';
		}

		// Preload works for both HTML and Flash
		if ($params->get('preload', '1') == '1') {
			$preload_html 	= ' preload="auto"';
			$preload_flash	= '"autoBuffering":true';
		} else {
			$preload_html 	= ' preload="none"';
			$preload_flash	= '"autoBuffering":false';
		}

		// Autoplay works for both HTML and Flash
		if ($autoplay == "1") {
			$autoplay_html 	= ' autoplay="autoplay"';
			$autoplay_flash	= '"autoPlay":true';
		} else {
			$autoplay_html 	= '';
			$autoplay_flash	= '"autoPlay":false';
		}

		// Actually loop works only for HTML
		if ($loop == "1") {
			$loop_html		= ' loop="loop"';
		} else {
			$loop_html 		= '';
		}
		
		// Poster image
		if ($image_visibility == "1") {
			$poster_html = ' poster="'.$image;
		} else {
			$poster_html = '';
		}

		// HTML output
		$html = '<div class="video-js-box'.$skin.'">
			<video id="mod_bo_videojs_'.$id.'" class="video-js" width="'.$width.'" height="'.$height.'" controls="controls"'.$autoplay_html.$preload_html.$loop_html.$poster_html.'">';

		if ($video_mp4 != "0") {
			$html .= '<source src="'.$video_mp4.'" type=\'video/mp4; codecs="avc1.42E01E, mp4a.40.2"\' />';
		}

		if ($video_webm != "0") {
			$html .= '<source src="'.$video_webm.'" type=\'video/webm; codecs="vp8, vorbis"\' />';
		}

		if ($video_ogg != "0") {
			$html .= '<source src="'.$video_ogg.'" type=\'video/ogg; codecs="theora, vorbis"\' />';
		}

		if ($flash != "0") {
			$html .= '<object id="mod_flash_fallback_'.$id.'" class="vjs-flash-fallback" width="'.$width.'" height="'.$height.'" type="application/x-shockwave-flash" data="http://releases.flowplayer.org/swf/flowplayer-3.2.1.swf">
	        		<param name="movie" value="http://releases.flowplayer.org/swf/flowplayer-3.2.1.swf" />';
	
			if ($wmode != 'default') {
				$html .= '<param name="wmode" value="'.$wmode.'"';			
			}

	        $html .= '<param name="allowfullscreen" value="true" />
	        		<param name="flashvars" value=\'config={"playlist":["'.$uri_image.$image.'", {"url": "'.$uri_flash.$flash.'",'.$autoplay_flash.','.$preload_flash.'}]}\' />';
	
			if ($image_visibility == "1") {
				$html .= '<img src="'.$image.'" width="'.$width.'" height="'.$height.'" alt="Poster Image" title="No video playback capabilities." />';
			}
			
			$html .= '</object>';
		}

		$html .= '</video>
				<p class="vjs-no-video"><strong>Download Video: </strong>';

		if ($video_mp4 != "0") {
			$html .= '<a href="'.$video_mp4.'">MP4</a>, ';
		}

		if ($video_webm != "0") {
			$html .= '<a href="'.$video_webm.'">WebM</a>, ';
		}

		if ($video_ogg != "0") {
			$html .= '<a href="'.$video_ogg.'">Ogg</a><br>';
		}

		$html .= '<a href="http://videojs.com">HTML5 Video Player</a> by VideoJS
			</p>
	  	</div>';

		return $html;

	}
}